stages:
  - build
  - deploy

container_image:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  before_script:
    - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"username\":\"${CI_REGISTRY_USER}\",\"password\":\"${CI_REGISTRY_PASSWORD}\"}}}" > /kaniko/.docker/config.json
  script:
    - /kaniko/executor
      --context ${CI_PROJECT_DIR}
      --dockerfile ${CI_PROJECT_DIR}/Dockerfile
      --destination ${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA}
      --destination ${CI_REGISTRY_IMAGE}:latest
  only:
    changes:
      - Dockerfile
      - requirements.txt
      - timerbot.py
  tags:
    - private
    - docker
    - kubernetes
    - amd64

k8spin:
  stage: deploy
  image: registry.gitlab.com/k8spin-open/container-images/kubectl:1.13.0
  variables:
    K8SPINHOST: https://api.k8spin.cloud
    # K8SPINTOKEN: AVAILABLE_AT_SETTING_CI_CD_VARIABLES
    K8SPINNAMESPACE: timerbot
    KUBECONFIG: /tmp/kubeconfig
    # TOKEN: THE_TELEGRAM_TOKEN__AVAILABLE_AT_SETTING_CI_CD_VARIABLES
  before_script:
    - curl -sSL https://raw.githubusercontent.com/k8spin/k8spin_cli/master/get.sh | sh -s -- -b /usr/local/bin
    - k8spin get_credentials ${K8SPINNAMESPACE} > /tmp/kubeconfig
  script:
    - kubectl create secret generic timerbot --from-literal=TOKEN=${TOKEN} --dry-run -o yaml | kubectl apply -f -
    - kubectl apply -f deployment.yml
  tags:
    - private
    - docker
    - kubernetes
    - amd64
